

function sample = BQR(nloop,burnin,y,X,p,prior,den_cont)
T = length(y);
q = size(X,2);

lags = 1;
beta_full = zeros(nloop-burnin,q,length(p));
beta_insample = [];


parfor bigloop = 1:length(p)
warning off
theta = (1-2*p(bigloop))/(p(bigloop)*(1-p(bigloop)));
tau2 = 2/(p(bigloop)*(1-p(bigloop)));

%% prior for beta
beta0 = zeros(q,1);

%% Minnesota type prior

if prior == 1

lambda1 = 0.2;
lambda2 = 0.2;
lambda3 = 1;

% %% generate OLS AR(4) std deviation for data
ARdata = [y X(:,3)]; % y-dependent variable (GDP) and x-independent variable
OLS_sigma = zeros(size(ARdata,2),1);
for ii = 1:size(ARdata,2)
yols = ARdata(5:end,ii); 
Xols = [ones(length(yols),1) ARdata(4:end-1,ii) ARdata(3:end-2,ii) ARdata(2:end-3,ii) ARdata(1:end-4,ii)];
betaols = (Xols'*Xols)\(Xols'*yols);
OLS_sigma(ii) = sqrt(sum((yols-Xols*betaols).^2)/(T-5));
end
% 
Vbeta = []; 
% Intercept
Vbeta = [Vbeta;1000*OLS_sigma(1)]; % Note assume OLS_sigma(1) is the GDP std dev from an AR(4) model
% lags of GDP
for v = 1:lags
    Vbeta = [Vbeta;lambda1/(v^lambda3)];   
end
% % Other parameters
Vbeta = [Vbeta;lambda1*lambda2*(repmat(OLS_sigma(1),q-1-lags,1)./OLS_sigma(2:end))];
invVbeta0 = sparse(1:q,1:q,1./(Vbeta.^2),q,q);
else
invVbeta0 = speye(q)*1/10;
end


z = exprnd(1,T,1);
nu0 = 5; S0 = .04;
newnu = nu0 + 3*T/2;
sig = 1;


store_beta = zeros(nloop-burnin,q);
store_z = zeros(nloop-burnin,T);
store_sig = zeros(nloop-burnin,1);
store_yhat = zeros(nloop-burnin,T);

%% MCMC starts here
randn('seed',sum(clock*100)); rand('seed',sum(clock*1000));
disp('Starting MCMC.... ');
disp(' ' );
start_time = clock;

for loop=1:nloop
 %% sample beta
 invOmega = sparse(1:T,1:T,1./(tau2*z*sig),T,T);
 Kbeta = X'*invOmega*X + invVbeta0;
 betahat = Kbeta\(X'*invOmega*(y-theta*z) + invVbeta0*beta0) ;
 beta = betahat+ chol( Kbeta,'lower')'\randn(q,1);
 
 %% sample z
 delta2 = ((y - X*beta).^2)./(tau2*sig);
 gam2 = 2/sig + theta^2/(tau2*sig);
 z = zeros(T,1);
 for t = 1:T
z(t) = gigrnd(.5, gam2, delta2(t),1);
 end

 
 if loop>burnin
    i = loop - burnin;
    store_beta(i,:) = beta';
    store_z(i,:) = z';
    store_sig(i,:) = sig;   
    store_yhat(i,:) = (X*beta)';
 end 
    
  
end
beta_full(:,:,bigloop) = store_beta;
beta_insample = [beta_insample;store_yhat];
end

if den_cont == 1

beta_full1 = beta_full(1:10:end,:,:);


sample = [];
parfor ii = 1:1000
    betahat = squeeze(beta_full1(ii,:,:));
    sample = [sample;(QR1(p,X,betahat)')];
end

else

sample = beta_insample;

end

